package dev.pfaff.glass.opengl;

import java.lang.foreign.MemorySegment;

public record MutPointer<T>(MemorySegment ms) implements Pointer<T> {
	public MutPointer {
		if (ms.equals(MemorySegment.NULL)) throw new NullPointerException("Attempted non-nullable construction of a MutPointer with NULL address");
		if (ms.isReadOnly()) throw new IllegalArgumentException();
	}

	public static <T> MutPointer<T> newNullable(MemorySegment ms) {
		return ms.equals(MemorySegment.NULL) ? null : new MutPointer<>(ms);
	}
}
