package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLClampColorModeARB implements GLEnum {
	FALSE(0x0),
	TRUE(0x1),
	FIXED_ONLY(0x891d);
	
	private final int glEnum;

	GLClampColorModeARB(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLClampColorModeARB> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLClampColorModeARB fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x0 -> FALSE;
			case 0x1 -> TRUE;
			case 0x891d -> FIXED_ONLY;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLClampColorModeARB");
		};
	}
}