package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLClipControlDepth implements GLEnum {
	NEGATIVE_ONE_TO_ONE(0x935e),
	ZERO_TO_ONE(0x935f);
	
	private final int glEnum;

	GLClipControlDepth(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLClipControlDepth> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLClipControlDepth fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x935e -> NEGATIVE_ONE_TO_ONE;
			case 0x935f -> ZERO_TO_ONE;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLClipControlDepth");
		};
	}
}