package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLColorMaterialParameter implements GLEnum {
	AMBIENT(0x1200),
	DIFFUSE(0x1201),
	SPECULAR(0x1202),
	EMISSION(0x1600),
	AMBIENT_AND_DIFFUSE(0x1602);
	
	private final int glEnum;

	GLColorMaterialParameter(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLColorMaterialParameter> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLColorMaterialParameter fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1200 -> AMBIENT;
			case 0x1201 -> DIFFUSE;
			case 0x1202 -> SPECULAR;
			case 0x1600 -> EMISSION;
			case 0x1602 -> AMBIENT_AND_DIFFUSE;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLColorMaterialParameter");
		};
	}
}