package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLColorTableParameterPName implements GLEnum {
	COLOR_TABLE_SCALE(0x80d6),
	COLOR_TABLE_BIAS(0x80d7),
	COLOR_TABLE_FORMAT(0x80d8),
	COLOR_TABLE_WIDTH(0x80d9),
	COLOR_TABLE_RED_SIZE(0x80da),
	COLOR_TABLE_GREEN_SIZE(0x80db),
	COLOR_TABLE_BLUE_SIZE(0x80dc),
	COLOR_TABLE_ALPHA_SIZE(0x80dd),
	COLOR_TABLE_LUMINANCE_SIZE(0x80de),
	COLOR_TABLE_INTENSITY_SIZE(0x80df);
	
	private final int glEnum;

	GLColorTableParameterPName(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLColorTableParameterPName> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLColorTableParameterPName fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x80d6 -> COLOR_TABLE_SCALE;
			case 0x80d7 -> COLOR_TABLE_BIAS;
			case 0x80d8 -> COLOR_TABLE_FORMAT;
			case 0x80d9 -> COLOR_TABLE_WIDTH;
			case 0x80da -> COLOR_TABLE_RED_SIZE;
			case 0x80db -> COLOR_TABLE_GREEN_SIZE;
			case 0x80dc -> COLOR_TABLE_BLUE_SIZE;
			case 0x80dd -> COLOR_TABLE_ALPHA_SIZE;
			case 0x80de -> COLOR_TABLE_LUMINANCE_SIZE;
			case 0x80df -> COLOR_TABLE_INTENSITY_SIZE;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLColorTableParameterPName");
		};
	}
}