package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLColorTableTargetSGI implements GLEnum {
	TEXTURE_COLOR_TABLE_SGI(0x80bc),
	PROXY_TEXTURE_COLOR_TABLE_SGI(0x80bd),
	COLOR_TABLE(0x80d0),
	POST_CONVOLUTION_COLOR_TABLE(0x80d1),
	POST_COLOR_MATRIX_COLOR_TABLE(0x80d2),
	PROXY_COLOR_TABLE(0x80d3),
	PROXY_POST_CONVOLUTION_COLOR_TABLE(0x80d4),
	PROXY_POST_COLOR_MATRIX_COLOR_TABLE(0x80d5);
	
	private final int glEnum;

	GLColorTableTargetSGI(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLColorTableTargetSGI> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLColorTableTargetSGI fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x80bc -> TEXTURE_COLOR_TABLE_SGI;
			case 0x80bd -> PROXY_TEXTURE_COLOR_TABLE_SGI;
			case 0x80d0 -> COLOR_TABLE;
			case 0x80d1 -> POST_CONVOLUTION_COLOR_TABLE;
			case 0x80d2 -> POST_COLOR_MATRIX_COLOR_TABLE;
			case 0x80d3 -> PROXY_COLOR_TABLE;
			case 0x80d4 -> PROXY_POST_CONVOLUTION_COLOR_TABLE;
			case 0x80d5 -> PROXY_POST_COLOR_MATRIX_COLOR_TABLE;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLColorTableTargetSGI");
		};
	}
}