package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLCombinerVariableNV implements GLEnum {
	VARIABLE_A_NV(0x8523),
	VARIABLE_B_NV(0x8524),
	VARIABLE_C_NV(0x8525),
	VARIABLE_D_NV(0x8526),
	VARIABLE_E_NV(0x8527),
	VARIABLE_F_NV(0x8528),
	VARIABLE_G_NV(0x8529);
	
	private final int glEnum;

	GLCombinerVariableNV(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLCombinerVariableNV> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLCombinerVariableNV fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8523 -> VARIABLE_A_NV;
			case 0x8524 -> VARIABLE_B_NV;
			case 0x8525 -> VARIABLE_C_NV;
			case 0x8526 -> VARIABLE_D_NV;
			case 0x8527 -> VARIABLE_E_NV;
			case 0x8528 -> VARIABLE_F_NV;
			case 0x8529 -> VARIABLE_G_NV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLCombinerVariableNV");
		};
	}
}