package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLConvolutionBorderModeEXT implements GLEnum {
	REDUCE(0x8016);
	
	private final int glEnum;

	GLConvolutionBorderModeEXT(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLConvolutionBorderModeEXT> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLConvolutionBorderModeEXT fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8016 -> REDUCE;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLConvolutionBorderModeEXT");
		};
	}
}