package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLDataTypeEXT implements GLEnum {
	SCALAR_EXT(0x87be),
	VECTOR_EXT(0x87bf),
	MATRIX_EXT(0x87c0);
	
	private final int glEnum;

	GLDataTypeEXT(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLDataTypeEXT> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLDataTypeEXT fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x87be -> SCALAR_EXT;
			case 0x87bf -> VECTOR_EXT;
			case 0x87c0 -> MATRIX_EXT;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLDataTypeEXT");
		};
	}
}