package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLFenceParameterNameNV implements GLEnum {
	FENCE_STATUS_NV(0x84f3),
	FENCE_CONDITION_NV(0x84f4);
	
	private final int glEnum;

	GLFenceParameterNameNV(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLFenceParameterNameNV> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLFenceParameterNameNV fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x84f3 -> FENCE_STATUS_NV;
			case 0x84f4 -> FENCE_CONDITION_NV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLFenceParameterNameNV");
		};
	}
}