package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLFfdTargetSGIX implements GLEnum {
	GEOMETRY_DEFORMATION_SGIX(0x8194),
	TEXTURE_DEFORMATION_SGIX(0x8195);
	
	private final int glEnum;

	GLFfdTargetSGIX(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLFfdTargetSGIX> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLFfdTargetSGIX fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8194 -> GEOMETRY_DEFORMATION_SGIX;
			case 0x8195 -> TEXTURE_DEFORMATION_SGIX;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLFfdTargetSGIX");
		};
	}
}