package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLFogCoordSrc implements GLEnum {
	FOG_COORDINATE(0x8451),
	FRAGMENT_DEPTH(0x8452);
	
	private final int glEnum;

	GLFogCoordSrc(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLFogCoordSrc> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLFogCoordSrc fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8451 -> FOG_COORDINATE;
			case 0x8452 -> FRAGMENT_DEPTH;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLFogCoordSrc");
		};
	}
}