package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLFogDistanceModeNV implements GLEnum {
	EYE_RADIAL_NV(0x855b),
	EYE_PLANE_ABSOLUTE_NV(0x855c);
	
	private final int glEnum;

	GLFogDistanceModeNV(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLFogDistanceModeNV> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLFogDistanceModeNV fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x855b -> EYE_RADIAL_NV;
			case 0x855c -> EYE_PLANE_ABSOLUTE_NV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLFogDistanceModeNV");
		};
	}
}