package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLFogMode implements GLEnum {
	EXP(0x800),
	EXP2(0x801),
	LINEAR(0x2601),
	FOG_FUNC_SGIS(0x812a);
	
	private final int glEnum;

	GLFogMode(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLFogMode> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLFogMode fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x800 -> EXP;
			case 0x801 -> EXP2;
			case 0x2601 -> LINEAR;
			case 0x812a -> FOG_FUNC_SGIS;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLFogMode");
		};
	}
}