package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLFoveationConfigBitQCOM implements GLEnum {
	FOVEATION_ENABLE_BIT_QCOM(0x1),
	FOVEATION_SCALED_BIN_METHOD_BIT_QCOM(0x2),
	FOVEATION_SUBSAMPLED_LAYOUT_METHOD_BIT_QCOM(0x4);
	
	private final int glEnum;

	GLFoveationConfigBitQCOM(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLFoveationConfigBitQCOM> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLFoveationConfigBitQCOM fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1 -> FOVEATION_ENABLE_BIT_QCOM;
			case 0x2 -> FOVEATION_SCALED_BIN_METHOD_BIT_QCOM;
			case 0x4 -> FOVEATION_SUBSAMPLED_LAYOUT_METHOD_BIT_QCOM;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLFoveationConfigBitQCOM");
		};
	}
}