package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLFragmentShaderColorModMaskATI implements GLEnum {
	_2X_BIT_ATI(0x1),
	COMP_BIT_ATI(0x2),
	NEGATE_BIT_ATI(0x4),
	BIAS_BIT_ATI(0x8);
	
	private final int glEnum;

	GLFragmentShaderColorModMaskATI(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLFragmentShaderColorModMaskATI> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLFragmentShaderColorModMaskATI fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1 -> _2X_BIT_ATI;
			case 0x2 -> COMP_BIT_ATI;
			case 0x4 -> NEGATE_BIT_ATI;
			case 0x8 -> BIAS_BIT_ATI;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLFragmentShaderColorModMaskATI");
		};
	}
}