package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLFragmentShaderDestModMaskATI implements GLEnum {
	NONE(0x0),
	_2X_BIT_ATI(0x1),
	_4X_BIT_ATI(0x2),
	_8X_BIT_ATI(0x4),
	HALF_BIT_ATI(0x8),
	QUARTER_BIT_ATI(0x10),
	EIGHTH_BIT_ATI(0x20),
	SATURATE_BIT_ATI(0x40);
	
	private final int glEnum;

	GLFragmentShaderDestModMaskATI(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLFragmentShaderDestModMaskATI> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLFragmentShaderDestModMaskATI fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x0 -> NONE;
			case 0x1 -> _2X_BIT_ATI;
			case 0x2 -> _4X_BIT_ATI;
			case 0x4 -> _8X_BIT_ATI;
			case 0x8 -> HALF_BIT_ATI;
			case 0x10 -> QUARTER_BIT_ATI;
			case 0x20 -> EIGHTH_BIT_ATI;
			case 0x40 -> SATURATE_BIT_ATI;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLFragmentShaderDestModMaskATI");
		};
	}
}