package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLInstancedPathCoverMode implements GLEnum {
	PATH_FILL_COVER_MODE_NV(0x9082),
	CONVEX_HULL_NV(0x908b),
	BOUNDING_BOX_NV(0x908d),
	BOUNDING_BOX_OF_BOUNDING_BOXES_NV(0x909c);
	
	private final int glEnum;

	GLInstancedPathCoverMode(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLInstancedPathCoverMode> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLInstancedPathCoverMode fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x9082 -> PATH_FILL_COVER_MODE_NV;
			case 0x908b -> CONVEX_HULL_NV;
			case 0x908d -> BOUNDING_BOX_NV;
			case 0x909c -> BOUNDING_BOX_OF_BOUNDING_BOXES_NV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLInstancedPathCoverMode");
		};
	}
}