package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLLightTexturePNameEXT implements GLEnum {
	ATTENUATION_EXT(0x834d),
	SHADOW_ATTENUATION_EXT(0x834e);
	
	private final int glEnum;

	GLLightTexturePNameEXT(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLLightTexturePNameEXT> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLLightTexturePNameEXT fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x834d -> ATTENUATION_EXT;
			case 0x834e -> SHADOW_ATTENUATION_EXT;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLLightTexturePNameEXT");
		};
	}
}