package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLListMode implements GLEnum {
	COMPILE(0x1300),
	COMPILE_AND_EXECUTE(0x1301);
	
	private final int glEnum;

	GLListMode(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLListMode> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLListMode fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1300 -> COMPILE;
			case 0x1301 -> COMPILE_AND_EXECUTE;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLListMode");
		};
	}
}