package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLMapParameterNV implements GLEnum {
	MAP_TESSELLATION_NV(0x86c2);
	
	private final int glEnum;

	GLMapParameterNV(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLMapParameterNV> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLMapParameterNV fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x86c2 -> MAP_TESSELLATION_NV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLMapParameterNV");
		};
	}
}