package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLMapTypeNV implements GLEnum {
	FLOAT(0x1406),
	DOUBLE(0x140a);
	
	private final int glEnum;

	GLMapTypeNV(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLMapTypeNV> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLMapTypeNV fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1406 -> FLOAT;
			case 0x140a -> DOUBLE;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLMapTypeNV");
		};
	}
}