package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLMeshMode1 implements GLEnum {
	POINT(0x1b00),
	LINE(0x1b01);
	
	private final int glEnum;

	GLMeshMode1(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLMeshMode1> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLMeshMode1 fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1b00 -> POINT;
			case 0x1b01 -> LINE;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLMeshMode1");
		};
	}
}