package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLOcclusionQueryParameterNameNV implements GLEnum {
	PIXEL_COUNT_NV(0x8866),
	PIXEL_COUNT_AVAILABLE_NV(0x8867);
	
	private final int glEnum;

	GLOcclusionQueryParameterNameNV(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLOcclusionQueryParameterNameNV> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLOcclusionQueryParameterNameNV fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8866 -> PIXEL_COUNT_NV;
			case 0x8867 -> PIXEL_COUNT_AVAILABLE_NV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLOcclusionQueryParameterNameNV");
		};
	}
}