package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLParameterRangeEXT implements GLEnum {
	NORMALIZED_RANGE_EXT(0x87e0),
	FULL_RANGE_EXT(0x87e1);
	
	private final int glEnum;

	GLParameterRangeEXT(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLParameterRangeEXT> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLParameterRangeEXT fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x87e0 -> NORMALIZED_RANGE_EXT;
			case 0x87e1 -> FULL_RANGE_EXT;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLParameterRangeEXT");
		};
	}
}