package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLPathColorFormat implements GLEnum {
	NONE(0x0),
	ALPHA(0x1906),
	RGB(0x1907),
	RGBA(0x1908),
	LUMINANCE(0x1909),
	LUMINANCE_ALPHA(0x190a),
	INTENSITY(0x8049);
	
	private final int glEnum;

	GLPathColorFormat(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLPathColorFormat> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLPathColorFormat fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x0 -> NONE;
			case 0x1906 -> ALPHA;
			case 0x1907 -> RGB;
			case 0x1908 -> RGBA;
			case 0x1909 -> LUMINANCE;
			case 0x190a -> LUMINANCE_ALPHA;
			case 0x8049 -> INTENSITY;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLPathColorFormat");
		};
	}
}