package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLPathElementType implements GLEnum {
	UTF8_NV(0x909a),
	UTF16_NV(0x909b);
	
	private final int glEnum;

	GLPathElementType(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLPathElementType> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLPathElementType fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x909a -> UTF8_NV;
			case 0x909b -> UTF16_NV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLPathElementType");
		};
	}
}