package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLPerfQueryDataFlags implements GLEnum {
	PERFQUERY_DONOT_FLUSH_INTEL(0x83f9),
	PERFQUERY_FLUSH_INTEL(0x83fa),
	PERFQUERY_WAIT_INTEL(0x83fb);
	
	private final int glEnum;

	GLPerfQueryDataFlags(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLPerfQueryDataFlags> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLPerfQueryDataFlags fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x83f9 -> PERFQUERY_DONOT_FLUSH_INTEL;
			case 0x83fa -> PERFQUERY_FLUSH_INTEL;
			case 0x83fb -> PERFQUERY_WAIT_INTEL;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLPerfQueryDataFlags");
		};
	}
}