package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLPixelDataRangeTargetNV implements GLEnum {
	WRITE_PIXEL_DATA_RANGE_NV(0x8878),
	READ_PIXEL_DATA_RANGE_NV(0x8879);
	
	private final int glEnum;

	GLPixelDataRangeTargetNV(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLPixelDataRangeTargetNV> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLPixelDataRangeTargetNV fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8878 -> WRITE_PIXEL_DATA_RANGE_NV;
			case 0x8879 -> READ_PIXEL_DATA_RANGE_NV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLPixelDataRangeTargetNV");
		};
	}
}