package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLPixelMap implements GLEnum {
	PIXEL_MAP_I_TO_I(0xc70),
	PIXEL_MAP_S_TO_S(0xc71),
	PIXEL_MAP_I_TO_R(0xc72),
	PIXEL_MAP_I_TO_G(0xc73),
	PIXEL_MAP_I_TO_B(0xc74),
	PIXEL_MAP_I_TO_A(0xc75),
	PIXEL_MAP_R_TO_R(0xc76),
	PIXEL_MAP_G_TO_G(0xc77),
	PIXEL_MAP_B_TO_B(0xc78),
	PIXEL_MAP_A_TO_A(0xc79);
	
	private final int glEnum;

	GLPixelMap(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLPixelMap> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLPixelMap fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0xc70 -> PIXEL_MAP_I_TO_I;
			case 0xc71 -> PIXEL_MAP_S_TO_S;
			case 0xc72 -> PIXEL_MAP_I_TO_R;
			case 0xc73 -> PIXEL_MAP_I_TO_G;
			case 0xc74 -> PIXEL_MAP_I_TO_B;
			case 0xc75 -> PIXEL_MAP_I_TO_A;
			case 0xc76 -> PIXEL_MAP_R_TO_R;
			case 0xc77 -> PIXEL_MAP_G_TO_G;
			case 0xc78 -> PIXEL_MAP_B_TO_B;
			case 0xc79 -> PIXEL_MAP_A_TO_A;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLPixelMap");
		};
	}
}