package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLPixelStoreResampleMode implements GLEnum {
	RESAMPLE_DECIMATE_SGIX(0x8430),
	RESAMPLE_REPLICATE_SGIX(0x8433),
	RESAMPLE_ZERO_FILL_SGIX(0x8434);
	
	private final int glEnum;

	GLPixelStoreResampleMode(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLPixelStoreResampleMode> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLPixelStoreResampleMode fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8430 -> RESAMPLE_DECIMATE_SGIX;
			case 0x8433 -> RESAMPLE_REPLICATE_SGIX;
			case 0x8434 -> RESAMPLE_ZERO_FILL_SGIX;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLPixelStoreResampleMode");
		};
	}
}