package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLPrecisionType implements GLEnum {
	LOW_FLOAT(0x8df0),
	MEDIUM_FLOAT(0x8df1),
	HIGH_FLOAT(0x8df2),
	LOW_INT(0x8df3),
	MEDIUM_INT(0x8df4),
	HIGH_INT(0x8df5);
	
	private final int glEnum;

	GLPrecisionType(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLPrecisionType> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLPrecisionType fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8df0 -> LOW_FLOAT;
			case 0x8df1 -> MEDIUM_FLOAT;
			case 0x8df2 -> HIGH_FLOAT;
			case 0x8df3 -> LOW_INT;
			case 0x8df4 -> MEDIUM_INT;
			case 0x8df5 -> HIGH_INT;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLPrecisionType");
		};
	}
}