package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLProgramFormat implements GLEnum {
	PROGRAM_FORMAT_ASCII_ARB(0x8875);
	
	private final int glEnum;

	GLProgramFormat(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLProgramFormat> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLProgramFormat fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8875 -> PROGRAM_FORMAT_ASCII_ARB;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLProgramFormat");
		};
	}
}