package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLProgramStagePName implements GLEnum {
	ACTIVE_SUBROUTINES(0x8de5),
	ACTIVE_SUBROUTINE_UNIFORMS(0x8de6),
	ACTIVE_SUBROUTINE_UNIFORM_LOCATIONS(0x8e47),
	ACTIVE_SUBROUTINE_MAX_LENGTH(0x8e48),
	ACTIVE_SUBROUTINE_UNIFORM_MAX_LENGTH(0x8e49);
	
	private final int glEnum;

	GLProgramStagePName(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLProgramStagePName> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLProgramStagePName fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8de5 -> ACTIVE_SUBROUTINES;
			case 0x8de6 -> ACTIVE_SUBROUTINE_UNIFORMS;
			case 0x8e47 -> ACTIVE_SUBROUTINE_UNIFORM_LOCATIONS;
			case 0x8e48 -> ACTIVE_SUBROUTINE_MAX_LENGTH;
			case 0x8e49 -> ACTIVE_SUBROUTINE_UNIFORM_MAX_LENGTH;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLProgramStagePName");
		};
	}
}