package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLQueryCounterTarget implements GLEnum {
	TIMESTAMP(0x8e28);
	
	private final int glEnum;

	GLQueryCounterTarget(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLQueryCounterTarget> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLQueryCounterTarget fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8e28 -> TIMESTAMP;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLQueryCounterTarget");
		};
	}
}