package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLQueryParameterName implements GLEnum {
	QUERY_COUNTER_BITS(0x8864),
	CURRENT_QUERY(0x8865);
	
	private final int glEnum;

	GLQueryParameterName(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLQueryParameterName> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLQueryParameterName fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8864 -> QUERY_COUNTER_BITS;
			case 0x8865 -> CURRENT_QUERY;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLQueryParameterName");
		};
	}
}