package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLSamplerParameterI implements GLEnum {
	TEXTURE_MAG_FILTER(0x2800),
	TEXTURE_MIN_FILTER(0x2801),
	TEXTURE_WRAP_S(0x2802),
	TEXTURE_WRAP_T(0x2803),
	TEXTURE_WRAP_R(0x8072),
	TEXTURE_COMPARE_MODE(0x884c),
	TEXTURE_COMPARE_FUNC(0x884d),
	TEXTURE_UNNORMALIZED_COORDINATES_ARM(0x8f6a);
	
	private final int glEnum;

	GLSamplerParameterI(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLSamplerParameterI> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLSamplerParameterI fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x2800 -> TEXTURE_MAG_FILTER;
			case 0x2801 -> TEXTURE_MIN_FILTER;
			case 0x2802 -> TEXTURE_WRAP_S;
			case 0x2803 -> TEXTURE_WRAP_T;
			case 0x8072 -> TEXTURE_WRAP_R;
			case 0x884c -> TEXTURE_COMPARE_MODE;
			case 0x884d -> TEXTURE_COMPARE_FUNC;
			case 0x8f6a -> TEXTURE_UNNORMALIZED_COORDINATES_ARM;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLSamplerParameterI");
		};
	}
}