package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLSemaphoreParameterName implements GLEnum {
	D3D12_FENCE_VALUE_EXT(0x9595),
	SEMAPHORE_TYPE_NV(0x95b3),
	SEMAPHORE_TYPE_BINARY_NV(0x95b4),
	SEMAPHORE_TYPE_TIMELINE_NV(0x95b5);
	
	private final int glEnum;

	GLSemaphoreParameterName(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLSemaphoreParameterName> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLSemaphoreParameterName fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x9595 -> D3D12_FENCE_VALUE_EXT;
			case 0x95b3 -> SEMAPHORE_TYPE_NV;
			case 0x95b4 -> SEMAPHORE_TYPE_BINARY_NV;
			case 0x95b5 -> SEMAPHORE_TYPE_TIMELINE_NV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLSemaphoreParameterName");
		};
	}
}