package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLShadingRate implements GLEnum {
	SHADING_RATE_1X1_PIXELS_EXT(0x96a6),
	SHADING_RATE_1X2_PIXELS_EXT(0x96a7),
	SHADING_RATE_2X1_PIXELS_EXT(0x96a8),
	SHADING_RATE_2X2_PIXELS_EXT(0x96a9),
	SHADING_RATE_1X4_PIXELS_EXT(0x96aa),
	SHADING_RATE_4X1_PIXELS_EXT(0x96ab),
	SHADING_RATE_4X2_PIXELS_EXT(0x96ac),
	SHADING_RATE_2X4_PIXELS_EXT(0x96ad),
	SHADING_RATE_4X4_PIXELS_EXT(0x96ae);
	
	private final int glEnum;

	GLShadingRate(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLShadingRate> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLShadingRate fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x96a6 -> SHADING_RATE_1X1_PIXELS_EXT;
			case 0x96a7 -> SHADING_RATE_1X2_PIXELS_EXT;
			case 0x96a8 -> SHADING_RATE_2X1_PIXELS_EXT;
			case 0x96a9 -> SHADING_RATE_2X2_PIXELS_EXT;
			case 0x96aa -> SHADING_RATE_1X4_PIXELS_EXT;
			case 0x96ab -> SHADING_RATE_4X1_PIXELS_EXT;
			case 0x96ac -> SHADING_RATE_4X2_PIXELS_EXT;
			case 0x96ad -> SHADING_RATE_2X4_PIXELS_EXT;
			case 0x96ae -> SHADING_RATE_4X4_PIXELS_EXT;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLShadingRate");
		};
	}
}