package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLTexBumpParameterATI implements GLEnum {
	BUMP_ROT_MATRIX_ATI(0x8775);
	
	private final int glEnum;

	GLTexBumpParameterATI(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLTexBumpParameterATI> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLTexBumpParameterATI fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8775 -> BUMP_ROT_MATRIX_ATI;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLTexBumpParameterATI");
		};
	}
}