package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLTexStorageAttribs implements GLEnum {
	SURFACE_COMPRESSION_EXT(0x96c0),
	SURFACE_COMPRESSION_FIXED_RATE_NONE_EXT(0x96c1),
	SURFACE_COMPRESSION_FIXED_RATE_DEFAULT_EXT(0x96c2),
	SURFACE_COMPRESSION_FIXED_RATE_1BPC_EXT(0x96c4),
	SURFACE_COMPRESSION_FIXED_RATE_2BPC_EXT(0x96c5),
	SURFACE_COMPRESSION_FIXED_RATE_3BPC_EXT(0x96c6),
	SURFACE_COMPRESSION_FIXED_RATE_4BPC_EXT(0x96c7),
	SURFACE_COMPRESSION_FIXED_RATE_5BPC_EXT(0x96c8),
	SURFACE_COMPRESSION_FIXED_RATE_6BPC_EXT(0x96c9),
	SURFACE_COMPRESSION_FIXED_RATE_7BPC_EXT(0x96ca),
	SURFACE_COMPRESSION_FIXED_RATE_8BPC_EXT(0x96cb),
	SURFACE_COMPRESSION_FIXED_RATE_9BPC_EXT(0x96cc),
	SURFACE_COMPRESSION_FIXED_RATE_10BPC_EXT(0x96cd),
	SURFACE_COMPRESSION_FIXED_RATE_11BPC_EXT(0x96ce),
	SURFACE_COMPRESSION_FIXED_RATE_12BPC_EXT(0x96cf);
	
	private final int glEnum;

	GLTexStorageAttribs(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLTexStorageAttribs> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLTexStorageAttribs fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x96c0 -> SURFACE_COMPRESSION_EXT;
			case 0x96c1 -> SURFACE_COMPRESSION_FIXED_RATE_NONE_EXT;
			case 0x96c2 -> SURFACE_COMPRESSION_FIXED_RATE_DEFAULT_EXT;
			case 0x96c4 -> SURFACE_COMPRESSION_FIXED_RATE_1BPC_EXT;
			case 0x96c5 -> SURFACE_COMPRESSION_FIXED_RATE_2BPC_EXT;
			case 0x96c6 -> SURFACE_COMPRESSION_FIXED_RATE_3BPC_EXT;
			case 0x96c7 -> SURFACE_COMPRESSION_FIXED_RATE_4BPC_EXT;
			case 0x96c8 -> SURFACE_COMPRESSION_FIXED_RATE_5BPC_EXT;
			case 0x96c9 -> SURFACE_COMPRESSION_FIXED_RATE_6BPC_EXT;
			case 0x96ca -> SURFACE_COMPRESSION_FIXED_RATE_7BPC_EXT;
			case 0x96cb -> SURFACE_COMPRESSION_FIXED_RATE_8BPC_EXT;
			case 0x96cc -> SURFACE_COMPRESSION_FIXED_RATE_9BPC_EXT;
			case 0x96cd -> SURFACE_COMPRESSION_FIXED_RATE_10BPC_EXT;
			case 0x96ce -> SURFACE_COMPRESSION_FIXED_RATE_11BPC_EXT;
			case 0x96cf -> SURFACE_COMPRESSION_FIXED_RATE_12BPC_EXT;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLTexStorageAttribs");
		};
	}
}