package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLTransformFeedbackBufferMode implements GLEnum {
	INTERLEAVED_ATTRIBS(0x8c8c),
	SEPARATE_ATTRIBS(0x8c8d);
	
	private final int glEnum;

	GLTransformFeedbackBufferMode(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLTransformFeedbackBufferMode> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLTransformFeedbackBufferMode fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8c8c -> INTERLEAVED_ATTRIBS;
			case 0x8c8d -> SEPARATE_ATTRIBS;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLTransformFeedbackBufferMode");
		};
	}
}