package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLTransformFeedbackTokenNV implements GLEnum {
	SKIP_COMPONENTS1_NV(0xfffffffa),
	SKIP_COMPONENTS2_NV(0xfffffffb),
	SKIP_COMPONENTS3_NV(0xfffffffc),
	SKIP_COMPONENTS4_NV(0xfffffffd),
	NEXT_BUFFER_NV(0xfffffffe);
	
	private final int glEnum;

	GLTransformFeedbackTokenNV(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLTransformFeedbackTokenNV> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLTransformFeedbackTokenNV fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0xfffffffa -> SKIP_COMPONENTS1_NV;
			case 0xfffffffb -> SKIP_COMPONENTS2_NV;
			case 0xfffffffc -> SKIP_COMPONENTS3_NV;
			case 0xfffffffd -> SKIP_COMPONENTS4_NV;
			case 0xfffffffe -> NEXT_BUFFER_NV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLTransformFeedbackTokenNV");
		};
	}
}