package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLTriangleFace implements GLEnum {
	FRONT(0x404),
	BACK(0x405),
	FRONT_AND_BACK(0x408);
	
	private final int glEnum;

	GLTriangleFace(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLTriangleFace> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLTriangleFace fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x404 -> FRONT;
			case 0x405 -> BACK;
			case 0x408 -> FRONT_AND_BACK;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLTriangleFace");
		};
	}
}