package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLUniformBlockPName implements GLEnum {
	UNIFORM_BLOCK_REFERENCED_BY_TESS_CONTROL_SHADER(0x84f0),
	UNIFORM_BLOCK_REFERENCED_BY_TESS_EVALUATION_SHADER(0x84f1),
	UNIFORM_BLOCK_BINDING(0x8a3f),
	UNIFORM_BLOCK_DATA_SIZE(0x8a40),
	UNIFORM_BLOCK_NAME_LENGTH(0x8a41),
	UNIFORM_BLOCK_ACTIVE_UNIFORMS(0x8a42),
	UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES(0x8a43),
	UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER(0x8a44),
	UNIFORM_BLOCK_REFERENCED_BY_GEOMETRY_SHADER(0x8a45),
	UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER(0x8a46),
	UNIFORM_BLOCK_REFERENCED_BY_COMPUTE_SHADER(0x90ec);
	
	private final int glEnum;

	GLUniformBlockPName(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLUniformBlockPName> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLUniformBlockPName fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x84f0 -> UNIFORM_BLOCK_REFERENCED_BY_TESS_CONTROL_SHADER;
			case 0x84f1 -> UNIFORM_BLOCK_REFERENCED_BY_TESS_EVALUATION_SHADER;
			case 0x8a3f -> UNIFORM_BLOCK_BINDING;
			case 0x8a40 -> UNIFORM_BLOCK_DATA_SIZE;
			case 0x8a41 -> UNIFORM_BLOCK_NAME_LENGTH;
			case 0x8a42 -> UNIFORM_BLOCK_ACTIVE_UNIFORMS;
			case 0x8a43 -> UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES;
			case 0x8a44 -> UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER;
			case 0x8a45 -> UNIFORM_BLOCK_REFERENCED_BY_GEOMETRY_SHADER;
			case 0x8a46 -> UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER;
			case 0x90ec -> UNIFORM_BLOCK_REFERENCED_BY_COMPUTE_SHADER;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLUniformBlockPName");
		};
	}
}