package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLVertexAttribPointerType implements GLEnum, IGLVertexAttribPointerType {
	BYTE(0x1400),
	UNSIGNED_BYTE(0x1401),
	SHORT(0x1402),
	UNSIGNED_SHORT(0x1403),
	INT(0x1404),
	UNSIGNED_INT(0x1405),
	FLOAT(0x1406),
	DOUBLE(0x140a),
	HALF_FLOAT(0x140b),
	FIXED(0x140c),
	INT64_ARB(0x140e),
	UNSIGNED_INT64_ARB(0x140f),
	UNSIGNED_INT_2_10_10_10_REV(0x8368),
	UNSIGNED_INT_10F_11F_11F_REV(0x8c3b),
	INT_2_10_10_10_REV(0x8d9f);
	
	private final int glEnum;

	GLVertexAttribPointerType(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLVertexAttribPointerType> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLVertexAttribPointerType fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1400 -> BYTE;
			case 0x1401 -> UNSIGNED_BYTE;
			case 0x1402 -> SHORT;
			case 0x1403 -> UNSIGNED_SHORT;
			case 0x1404 -> INT;
			case 0x1405 -> UNSIGNED_INT;
			case 0x1406 -> FLOAT;
			case 0x140a -> DOUBLE;
			case 0x140b -> HALF_FLOAT;
			case 0x140c -> FIXED;
			case 0x140e -> INT64_ARB;
			case 0x140f -> UNSIGNED_INT64_ARB;
			case 0x8368 -> UNSIGNED_INT_2_10_10_10_REV;
			case 0x8c3b -> UNSIGNED_INT_10F_11F_11F_REV;
			case 0x8d9f -> INT_2_10_10_10_REV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLVertexAttribPointerType");
		};
	}

	@Override
	public java.lang.foreign.ValueLayout layout() {
		return switch (this) {
			case BYTE -> java.lang.foreign.ValueLayout.JAVA_BYTE;
			case UNSIGNED_BYTE -> java.lang.foreign.ValueLayout.JAVA_BYTE;
			case SHORT -> java.lang.foreign.ValueLayout.JAVA_SHORT;
			case UNSIGNED_SHORT -> java.lang.foreign.ValueLayout.JAVA_SHORT;
			case INT -> java.lang.foreign.ValueLayout.JAVA_INT;
			case UNSIGNED_INT -> java.lang.foreign.ValueLayout.JAVA_INT;
			case FLOAT -> java.lang.foreign.ValueLayout.JAVA_FLOAT;
			case DOUBLE -> java.lang.foreign.ValueLayout.JAVA_DOUBLE;
			case HALF_FLOAT -> java.lang.foreign.ValueLayout.JAVA_CHAR;
			case FIXED -> java.lang.foreign.ValueLayout.JAVA_INT;
			case INT64_ARB -> java.lang.foreign.ValueLayout.JAVA_LONG;
			case UNSIGNED_INT64_ARB -> java.lang.foreign.ValueLayout.JAVA_LONG;
			case UNSIGNED_INT_2_10_10_10_REV -> java.lang.foreign.ValueLayout.JAVA_INT;
			case UNSIGNED_INT_10F_11F_11F_REV -> java.lang.foreign.ValueLayout.JAVA_INT;
			case INT_2_10_10_10_REV -> java.lang.foreign.ValueLayout.JAVA_INT;
		};
	}
}